/**
 * MGTP.java for PTV:MGTP 15-Apr-2000
 * Copyright (c) 1997-2000 Kyushu University
 **/

/*
 * Modification for PTVisualizer:
 *  MGTP.java (this file) .. ptv_prove etc. added
 *  Term.java .. ptv_onTM added
 *  Cnsq.java .. length added
 *
 * [cmgtp32lnew-time]
 * : cmgtp32lnew-time/MGTP.java 25-Mar-2000
 *
 * updated 31-Mar-2000
 * updated 25-Mar-2000
 * pdlnF, mdlnF, ndlnF  deleted  21-Feb-2000
 *
 */

package mgtp;

import ptv.*;
import java.io.*;

public class MGTP extends MGTP0 { // %%% public: PTV
  //  static String version="MGTP Version 1.1 31-Mar-2000";
  //  static String copyRight="Copyright (c) 1997-2000 Kyushu University";
  //  static String ifile;
  //  static String inputName, fileName, directory, path, fullPath, probName;
  //  static File inputFile;
  //  static boolean verbose,allSol,selectMin,compileExt;
  //  static MGTPParser parser;
  //  static MGTP mgtp;
  //  static long time;
  //  static int repeat=0;
  //  static boolean ptvmode=false;
  // %%% public: PTV
  public static String version="MGTP Version 1.2 15-Apr-2000";
  public static String copyRight="Copyright (c) 1997-2000 Kyushu University";
  public static String ifile;
  public static String inputName, fileName;
  public static String directory, path, fullPath, probName;
  public static File inputFile;
  public static boolean verbose,allSol,selectMin,compileExt;
  public static MGTPParser parser;
  public static MGTP mgtp;
  //  public static long time; // %%%
  public static int repeat=0;
  public static boolean ptvmode=false;
  public static boolean excmode=false; // %%%
  public static Exec exc; // %%%
  // %%%

  CList Cls=new CList();
  Clauses posCls=new Clauses();
  Clauses negCls=new Clauses();
  Clauses cntCls=new Clauses();
  Clauses mixCls=new Clauses();

  // %%% PTV
  public MGTP(Prove prove) { pv=prove; }
  public MGTP() {}
  // %%%

  public static void main(String args[]) {
    System.out.println(version);
    System.out.println(copyRight);
    setupOptions(args);
    java.io.FileInputStream fis=null;

    try {
      //      inputFile = new File(inputName);
      //      fileName = inputFile.getName();
      //      directory = inputFile.getParent();
      //      path = inputFile.getPath();
      //      fullPath = inputFile.getAbsolutePath();
      //      int i=fileName.lastIndexOf(".");
      //      probName = (i<0 ? fileName : fileName.substring(0,i));
      //      System.out.println("inputName: "+inputName);
      fis=new java.io.FileInputStream(inputName);
    } catch (java.io.FileNotFoundException e) {
      System.out.println("File "+inputName+" not found.");
      return;
    }

    parser=new MGTPParser(fis);
    mgtp=(selectMin ? new MGTPpickupMin() : new MGTP());
    System.out.println("selectMin ="+selectMin);
    //    main_common();
    mgtp.main_common();
  }

  // %%% PTV
  public static void ptv_main(String args[],java.io.FileInputStream fis) {
    parser=new MGTPParser(fis);
    ptvmode=true;
    excmode=false; // %%%
    //    main_common();
    mgtp.main_common();
  }

  public static void ptv_main(String args[],java.io.FileInputStream fis, 
			      Exec exec) {
    parser=new MGTPParser(fis);
    exc=exec;
    ptvmode=false;
    excmode=true;
    //    main_common();
    mgtp.main_common();
  }

  //  public static void main_common(){
  public void main_common(){
    inputFile = new File(inputName);
    fileName = inputFile.getName();
    directory = inputFile.getParent();
    path = inputFile.getPath();
    fullPath = inputFile.getAbsolutePath();
    int i=fileName.lastIndexOf(".");
    probName = (i<0 ? fileName : fileName.substring(0,i));
    // %%%

    System.out.println("Reading from file "+inputName+" . . .");
    time=System.currentTimeMillis();
    if (!parser.parse(mgtp)) return;
    time=System.currentTimeMillis()-time;
    System.out.println("Parsing time: "+time+" msec");

    if (verbose) {
      //      Counter.report();
      //      mgtp.counter_reset();
      mgtp.out_print_parse();
    }
    System.gc();
    System.out.println("Proving . . .");

    Counter.reset(); // %%% essential

    mgtp.ac=new ACell();
    time=System.currentTimeMillis();
    mgtp.posCls.first.cjmCL(null);

    // %%% PTV
    if(ptvmode) mgtp.ptv_prove();
    else mgtp.prove();
    // %%%

    time=System.currentTimeMillis()-time;

    if (excmode) exc.doneProve(); // %%% PTV

    Counter.report();
    mgtp.out_print_default();

    if (repeat>0) {
      System.gc();
      System.out.println("\nProving again (repeat="+repeat+" times) . . .");
      time=System.currentTimeMillis();
      mgtp.prove(repeat);
      time=System.currentTimeMillis()-time;
      //      mgtp.out_print_repeat();
      System.out.println("\nProving time ("+repeat+" times): "+time+" msec");
      System.out.println("Proving time (average): "+
			 (((float)time)/((float)repeat))+" msec");
    }
  }
  
  public static void setupOptions(String args[]) {
    for (int i=0; i<args.length; i++) {
      if ("verbose".startsWith(args[i])) {verbose=true; continue;}
      if ("all".startsWith(args[i])) {allSol=true; continue;}
      if ("min".startsWith(args[i])) {selectMin=true; continue;}
      if ("ext".startsWith(args[i])) {compileExt=true; continue;}
      if ("repeat".startsWith(args[i])) {
	i++;
	repeat=Integer.parseInt(args[i]);
	continue;
      }
      inputName=args[i];
    }
  }

  // %%% PTV
  public void set_pt_top(MGTP0 m) {
    brosnum=0;
    pt_top=new GT(new UATerm("root"),m); // ###
    curGT=pt_top;
    ptv.rootGT=pt_top; // %%%
    ptv.max_gene=0;    // %%%
    pt_top.max_gene=0;    // ###
    pt_top.rootGT=pt_top; // ###
    gtc.inc(pt_top);   // %%%
  }
  // %%%

  //  %%% moved to MGTP0
  //  int models,failedBranches,branches,atoms;

  boolean sat;

  //Model pModel=Model.NIL; Model nModel=Model.NIL;
  boolean pModel=false; boolean nModel=false;

  //  %%% move to MGTP0
  //  int brosnum=0;
  //  GT pt_top=new GT(new UATerm("root"),this);
  //  GT curGT=pt_top;
  //  Prove prv;

  TMNode TM; 
  GStack gstack;
  UList unitF,unitL,domsF,domsL;
  DList pdlF=DList.NIL; DList pdlL=DList.NIL; DList pdlnF=DList.NIL;
  DList ndlF=DList.NIL; DList ndlL=DList.NIL; DList ndlnF=DList.NIL;
  DList mdlF=DList.NIL; DList mdlL=DList.NIL; DList mdlnF=DList.NIL;
  Cnsq disj,nextd; GTerm delta; int atomID;
  boolean closed=false;
  RDlList rll=RDlList.NIL;
  RDjList rjl=RDjList.NIL;
  RNdList rnl=RNdList.NIL;
  RSkChain rsc=RSkChain.NIL;
  ACell ac=new ACell();
  

  void counter_reset() {
    models=0;
    failedBranches=0;
    branches=0;
    atoms=0;
    //Counter.reset();
  }

  void init() {
    // 
    models=0;
    failedBranches=0;
    branches=0;
    atoms=0;
    Counter.reset();
    //
    sat=false;
    closed=false;
    ac=new ACell();
    atomID=0;
    //pModel=nModel=Model.NIL;
    pModel=nModel=false;
    unitF=unitL=domsF=domsL=null;
    pdlF=pdlL=ndlF=ndlL=mdlF=mdlL=pdlnF=ndlnF=mdlnF=DList.NIL;
    rll=RDlList.NIL;
    rjl=RDjList.NIL;
    rnl=RNdList.NIL;
    rsc=RSkChain.NIL;
  }

  void reset() {
    rjl.restore();
    rll.restore();
    rnl.restore();
    rsc.restore();
    ac.reset();
    if (gstack!=null) {
      gstack.all_restore();
      gstack=null;
    }
  }

  void prove(int rep) {
    while (rep>0) {
      reset();
      init();
      posCls.first.cjmCL(null);
      prove();
      rep--;
    }
  }

  void out_print_parse() {
      System.out.println("\n"
			 +"Positive clause(s):\n"+posCls
			 +"Negative clause(s):\n"+negCls
			 +"Cont. clause(s):\n"+cntCls
			 +"Mixed clause(s):\n"+mixCls);
  }

  void out_print_default() {
    System.out.println("Number of models: "+models+"\n"
		       +"Number of failed branches: "+failedBranches+"\n"
		       +"Number of total atoms: "+atoms+"\n"
		       +(mgtp.sat? "SAT": "UNSAT")
		       +"\nProving time (including JIT time): "+time+" msec");
  }

  void out_print_repeat() {
    System.out.println("\n"
		       +"Number of models: "+models+"\n"
		       +"Number of failed branches: "+failedBranches+"\n"
		       +"Number of total atoms: "+atoms+"\n"
		       +(mgtp.sat? "SAT": "UNSAT")
		       +"\nProving time: "+time+" msec");
  }

  
  void prove() {
    main_loop: do {
      delta=null;
      pickup: do {
        if (unitF!=null) { 
          // Pickup from Unit Buf
          Counter.upickup++;
	  delta=unitF.atm; unitF=unitF.tl; 
          break;
        }
        if (pdlF!=DList.NIL || ndlF!=DList.NIL || mdlF!=DList.NIL) {
          // Disj Buf Simplification
          //if (pdlF!=DList.NIL&&nModel!=Model.NIL) {
	  if (pdlF!=DList.NIL&&nModel) {
            pdlF.psimplify(this); pdlnF=DList.NIL; }
          //if (ndlF!=DList.NIL&&pModel!=Model.NIL) {
	  if (ndlF!=DList.NIL&&pModel) {
	    ndlF.nsimplify(this); ndlnF=DList.NIL; }
          //if (mdlF!=DList.NIL&&(nModel!=Model.NIL||pModel!=Model.NIL)) {
	  if (mdlF!=DList.NIL&&(nModel||pModel)) {
	  mdlF.msimplify(this); mdlnF=DList.NIL; }

          if (closed) break; // UNSAT by simplification
          if (unitF!=null) continue pickup;

          // Pickup from Disj Buf
          if (pickupDisj()) {

	    // %%% perform this block before moveToBuf.
	    ACell parAC=ac; // save parent's AC

	    ac=new ACell(); // get a new AC for the leftmost child
	    delta=(GTerm)disj.hd;
            delta.setac(mgtp);
	    // %%%

            nextd=disj.moveToBuf(disj.dn,this);
	    gstack=new GStack(pModel,nModel,nextd,atomID,
	                      pdlF,pdlL,ndlF,ndlL,mdlF,mdlL,domsF,domsL,
			      rjl,rll,rnl,rsc,parAC,gstack); // %%%
            rjl=RDjList.NIL;
	    rll=RDlList.NIL;
	    rnl=RNdList.NIL;
	    rsc=RSkChain.NIL;

            break;
          }
        }
        if (domsF!=null) {
          // Pickup from Dom Buf
          delta=domsF.atm; domsF=domsF.tl; 
          break;
        }
        break;  // important
      } while(true); // pickup end

      if (delta==null&&!closed) {
        // SAT
	if (verbose) {
	  //if (pModel==Model.NIL) System.out.println("pModel: []");
	  if (!pModel) System.out.println("pModel: []");
	  else System.out.println("pModel: "+pModel);
	  //if (nModel==Model.NIL) System.out.println("nModel: []");
	  if (!nModel) System.out.println("nModel: []");
	  else System.out.println("nModel: "+nModel);
	}
	branches++; models++; sat=true;
	if (!allSol||gstack==null) return;
	nextBranch();
      }

      fcheck: do {
        if (closed) {
          // UNSAT
	  if (verbose) {
	    System.out.println("reject: "+pModel+"\n"+
			       "        "+nModel);
	  }
          branches++; failedBranches++;

          closed=false;
	  if (gstack==null) return;
          nextBranch();

	  if (closed) continue fcheck; // %%%
        }
        // Add delta to Model
        atomID++; atoms++;
        delta.onTM(mgtp);

        if (verbose) {
          System.out.print(""+atomID+": "+delta+".\n");
        }
        // False check with delta
        // Model Candidate Generation with delta

	delta.Cls.cjmCL(delta);

        if (closed) continue fcheck;
        break;

      } while(true); // fcheck end

    } while (true); // main_loop end
  }
  
  // %%% PTV
  void ptv_prove() {
    main_loop: do {
      delta=null;
      pickup: do {
        if (unitF!=null) { 
          // Pickup from Unit Buf
          Counter.upickup++;
	  delta=unitF.atm; unitF=unitF.tl; 
          break;
        }
        if (pdlF!=DList.NIL || ndlF!=DList.NIL || mdlF!=DList.NIL) {
          // Disj Buf Simplification
          //if (pdlF!=DList.NIL&&nModel!=Model.NIL) {
	  if (pdlF!=DList.NIL&&nModel) {
            pdlF.psimplify(this); pdlnF=DList.NIL; }
          //if (ndlF!=DList.NIL&&pModel!=Model.NIL) {
	  if (ndlF!=DList.NIL&&pModel) {
	    ndlF.nsimplify(this); ndlnF=DList.NIL; }
          //if (mdlF!=DList.NIL&&(nModel!=Model.NIL||pModel!=Model.NIL)) {
	  if (mdlF!=DList.NIL&&(nModel||pModel)) {
	  mdlF.msimplify(this); mdlnF=DList.NIL; }

          if (closed) break; // UNSAT by simplification
          if (unitF!=null) continue pickup;

          // Pickup from Disj Buf
          if (pickupDisj()) {

	    // %%% perform this block before moveToBuf.
	    ACell parAC=ac; // save parent's AC

	    ac=new ACell(); // get a new AC for the leftmost child
	    delta=(GTerm)disj.hd; 
	    delta.setac(mgtp); 
	    // %%%
	    
            nextd=disj.moveToBuf(disj.dn,this);

	    brosnum=disj.length(); // %%% PTV

	    gstack=new GStack(pModel,nModel,curGT,nextd,atomID,
	                      pdlF,pdlL,ndlF,ndlL,mdlF,mdlL,domsF,domsL,
		              rjl,rll,rnl,rsc,parAC,gstack); // %%%
            rjl=RDjList.NIL;
	    rll=RDlList.NIL;
	    rnl=RNdList.NIL;
	    rsc=RSkChain.NIL;

	    // %%% PTV
	    if (closed) {
	      delta.ptv_onTM(this);
	      gtc.inc(curGT); 
	    }
	    // %%%

            break;
          }
        }
        if (domsF!=null) {
          // Pickup from Dom Buf
          delta=domsF.atm; domsF=domsF.tl; 
          break;
        }
        break;  // important
      } while(true); // pickup end

      if (delta==null&&!closed) {
        // SAT
	if (verbose) {
	  //if (pModel==Model.NIL) System.out.println("pModel: []");
	  if (!pModel) System.out.println("pModel: []");
	  else System.out.println("pModel: "+pModel);
	  //if (nModel==Model.NIL) System.out.println("nModel: []");
	  if (!nModel) System.out.println("nModel: []");
	  else System.out.println("nModel: "+nModel);
	}
	branches++; models++; sat=true;

	curGT.putcolor("pink"); // %%% PTV

	if (!allSol||gstack==null) return;
	ptv_nextBranch(); // %%% PTV
      }

      fcheck: do {
        if (closed) {
          // UNSAT
	  if (verbose) {
	    System.out.println("reject: "+pModel+"\n"+
			       "        "+nModel);
	  }
          branches++; failedBranches++;

	  curGT.putcolor("blue"); // %%% PTV

          closed=false;
	  if (gstack==null) return;
          ptv_nextBranch(); // %%% PTV

	  if (closed) continue fcheck; // %%%
        }
        // Add delta to Model
        atomID++; atoms++;
        
	delta.ptv_onTM(mgtp); // %%% PTV
	gtc.inc(curGT); // %%% PTV

        if (verbose) {
          System.out.print(""+atomID+": "+delta+".\n");
        }
        // False check with delta
        // Model Candidate Generation with delta

	delta.Cls.cjmCL(delta);

        if (closed) continue fcheck;
        break;

      } while(true); // fcheck end

    } while (true); // main_loop end
  }

  class GStack {
    //Model pModel,nModel;
    boolean pModel,nModel;
    GT curGT; // %%% PTV
    Cnsq nextd; int atomID;
    DList pdlF,pdlL,ndlF,ndlL,mdlF,mdlL;
    UList domsF,domsL;
    RDjList rjl;
    RDlList rll;
    RNdList rnl;
    RSkChain rsc;
    ACell ac;
    GStack tl;
    //GStack(Model pm, Model nm,
    GStack(boolean pm, boolean nm,
	   Cnsq nd, int id,
	   DList pf, DList pl, DList nf, DList nl, DList mf, DList ml,
	   UList of, UList ol,
	   RDjList rj,
	   RDlList rl,
	   RNdList rn,
           RSkChain rc,
	   ACell a,
	   GStack s) {
      pModel=pm; nModel=nm;
      nextd=nd; atomID=id;
      pdlF=pf; pdlL=pl; ndlF=nf; ndlL=nl; mdlF=mf; mdlL=ml;
      domsF=of; domsL=ol;
      rjl=rj;
      rll=rl;
      rnl=rn;
      rsc=rc;
      ac=a;
      tl=s;}
    GStack(boolean pm, boolean nm, GT gt, // %%% PTV
    //GStack(Model pm, Model nm, GT gt,
	   Cnsq nd, int id,
	   DList pf, DList pl, DList nf, DList nl, DList mf, DList ml,
	   UList of, UList ol,
	   RDjList rj,
	   RDlList rl,
	   RNdList rn,
           RSkChain rc,
	   ACell a,
	   GStack s) {
      pModel=pm; nModel=nm;
      curGT=gt; // %%% PTV
      nextd=nd; atomID=id;
      pdlF=pf; pdlL=pl; ndlF=nf; ndlL=nl; mdlF=mf; mdlL=ml;
      domsF=of; domsL=ol;
      rjl=rj;
      rll=rl;
      rnl=rn;
      rsc=rc;
      ac=a;
      tl=s;}

  void all_restore() {
    GStack gs=this;
    while (gs!=null) {
      gs.rjl.restore();
      gs.rll.restore();
      gs.rnl.restore();
      gs.rsc.restore();
      gs.ac.reset();
      gs=gs.tl;
    }
  }

  }


  void nextBranch() {
    rjl.restore();
    rll.restore();
    ac.reset();

    pModel=gstack.pModel;
    nModel=gstack.nModel;
    unitF=unitL=null;
    atomID=gstack.atomID;
    pdlF=gstack.pdlF;
    pdlL=gstack.pdlL;
    if (pdlL!=DList.NIL) {pdlL.tl=DList.NIL;}
    ndlF=gstack.ndlF;
    ndlL=gstack.ndlL;
    if (ndlL!=DList.NIL) {ndlL.tl=DList.NIL;}
    mdlF=gstack.mdlF;
    mdlL=gstack.mdlL;
    if (mdlL!=DList.NIL) {mdlL.tl=DList.NIL;}
    domsF=gstack.domsF;
    domsL=gstack.domsL;
    if (domsL!=null) {domsL.tl=null;}
    nextd=gstack.nextd;

    ac=new ACell(); // %%%
    delta=(GTerm)nextd.hd;

    //Counter.accheck++;
    //Counter.npickup++;
    delta.setac(mgtp);

    nextd=nextd.moveToBuf(nextd.dn,this);

    if (nextd==null) { // pop up
      rjl=gstack.rjl; // commit rightmost child's restore to parent
      rll=gstack.rll;
      rnl.restore();
      rnl=gstack.rnl;
      rsc.restore();
      rsc=gstack.rsc;
      ac.tl=gstack.ac;
      gstack=gstack.tl;
    } else {
      rjl=RDjList.NIL;
      rll=RDlList.NIL;
      gstack.nextd=nextd;
    }	
  }

  void ptv_nextBranch() {
    rjl.restore();
    rll.restore();
    ac.reset();

    pModel=gstack.pModel;
    nModel=gstack.nModel;

    curGT=gstack.curGT; // %%% PTV

    unitF=unitL=null;
    atomID=gstack.atomID;
    pdlF=gstack.pdlF;
    pdlL=gstack.pdlL;
    if (pdlL!=DList.NIL) {pdlL.tl=DList.NIL;}
    ndlF=gstack.ndlF;
    ndlL=gstack.ndlL;
    if (ndlL!=DList.NIL) {ndlL.tl=DList.NIL;}
    mdlF=gstack.mdlF;
    mdlL=gstack.mdlL;
    if (mdlL!=DList.NIL) {mdlL.tl=DList.NIL;}
    domsF=gstack.domsF;
    domsL=gstack.domsL;
    if (domsL!=null) {domsL.tl=null;}
    nextd=gstack.nextd;

    ac=new ACell();
    delta=(GTerm)nextd.hd;

    //Counter.accheck++;
    //Counter.npickup++;
    delta.setac(mgtp);

    nextd=nextd.moveToBuf(nextd.dn,this);

    // %%% PTV
    if (closed) {
      delta.ptv_onTM(this);
      gtc.inc(curGT); 
    }
    // %%%

    if (nextd==null) { // pop up
      rjl=gstack.rjl; // commit rightmost child's restore to parent
      rll=gstack.rll;
      rnl.restore();
      rnl=gstack.rnl;
      rsc.restore();
      rsc=gstack.rsc;
      ac.tl=gstack.ac;
      gstack=gstack.tl;
    } else {
      rjl=RDjList.NIL;
      rll=RDlList.NIL;
      gstack.nextd=nextd;
    }	
  }

  boolean pickupDisj() {
  next: do {
    if (pdlF!=DList.NIL) {
      //Counter.dsubs++;
      disj=pdlF.disj.subsumedDj(this);
      pdlF=pdlF.tl;
      if (disj==null) continue next;
      else Counter.dsubspass++;
    } else if (ndlF!=DList.NIL) {
      //Counter.dsubs++;
      disj=ndlF.disj.subsumedDj(this);
      ndlF=ndlF.tl;
      if (disj==null) continue next;
      else Counter.dsubspass++;
    } else if (mdlF!=DList.NIL) {
      //Counter.dsubs++;
      disj=mdlF.disj.subsumedDj(this);
      mdlF=mdlF.tl;
      if (disj==null) continue next;
      else Counter.dsubspass++;
    } else {
      return false;
    }
    return true;
  } while (true);
  }

}

/*
class MGTPpickupMin extends MGTP {
  //
  MGTPpickupMin(){}
  MGTPpickupMin(Prove prove){pv=prove;} // %%%
  //
  boolean pickupDisj() {
  next: do {
    if (pdlF!=DList.NIL) {
      //Counter.dsubs++;
      disj=pdlF.pfind_Min(this).subsumedDj(this);
      if (disj==null) continue next;
      else Counter.dsubspass++;
    } else if (ndlF!=DList.NIL) {
      //Counter.dsubs++;
      disj=ndlF.nfind_Min(this).subsumedDj(this);
      if (disj==null) continue next;
      else Counter.dsubspass++;
    } else if (mdlF!=DList.NIL) {
      //Counter.dsubs++;
      disj=mdlF.mfind_Min(this).subsumedDj(this);
      if (disj==null) continue next;
      else Counter.dsubspass++;
    } else return false;
    return true;
  } while (true);
  }
}
*/

/*
class Model {
  public static Model NIL=new Model();
  Term hd; Model tl;
  Model() {}
  Model(GTerm delta) {hd=delta; tl=NIL;}
  Model(GTerm delta, Model model) {hd=delta; tl=model;}
  public String toString() {
    if (this==NIL) return "[]";
    String s="[ "; Model m=this;
    while (m.tl!=NIL) {s=s+m.hd+", "; m=m.tl;}
    return s+m.hd+" ]";
  }
}
*/

class UList {
  GTerm atm; UList tl;
  UList(Term t) {atm=(GTerm)t;}
  public String toString() {return ""+atm;}
}

class ACell {
  public static ACell OFF=new ACell(false);
  boolean act; ACell tl;
  ACell() {act=true;}
  ACell(boolean b) {act=b;}
  void reset() {ACell r=this; while (r!=null) {r.act=false; r=r.tl;}}
}

// eof
