/**
 * GT.java 12-Apr-2000
 * Copyright (c) 1997-2000 Kyushu University
 **/

package ptv;

import java.lang.*;
import java.awt.*;

//import mgtp.*;


public class GT {
  int ds=0;
  GT son;
  GT next;
  GT par;
  GT last;
  float x;float y;
  float L;float W;
  float F;float A;float R;float T;
  //  Color p_color=Color.black;
  Color p_color=PTCanvas.node_color;
  Color old_color;
  int bros;
  int gene;
  int born_n;

  public static GT rootGT; // %%%
  public static int max_gene;
  static boolean redraw_flag;
  static float step;

  public GT() {}

  //  ###
  Term0 lit; 

  public GT(Term0 a,MGTP0 mgtp) {
    lit=a;
    bros=1;
    gene=0;
  }
    
  public GT(Term0 t,GT cgt){
    lit=t;
    par=cgt;
    bros=1;
  }

  public GT(Term0 t,GT cgt,int bn) {
    lit=t;
    par=cgt;
    bros=bn;
  }
  //  ###

  public String toStr() {return ""+lit.toStr();}

  /*  
  public String get_term() {
    String str; int i;
    str=""+lit;
    i=str.indexOf("/");
    if (i==-1) return str;
    return str.substring(0,i)+
      str.substring(str.indexOf("("),str.lastIndexOf(")")+1);
  }
  */

  public String unparseS_txtF(int i) {
    String s="";
    for (int j=0; j<i; j++) s=s+" ";
    //    s=s+atom.unparse()+"("+ds+","+cs+","+gs+","+x+","+y+
    //      ","+L+","+W+","+H+","+D+")";
    //    s=s+m.hd+"("+bros+","+gene+","+born_n+","+x+","+y+
    //      ","+L+","+W+","+color_inf(p_color) +")";
    //    s=s+m.hd+"("+bros+","+gene+","+born_n+")";
    //    s=s+m.hd+" ("+gene+","+bros+","+(born_n+1)+")";
    //    s=s+lit+" (gn:"+gene+", br:"+bros+", bn:"+(born_n+1)+")";
    //    s=s+toStr()+" : gn="+gene+", br="+bros+", bn="+(born_n+1);
    s=s+toStr()+" : gn="+gene+", br="+bros+", bn="+(born_n+1)+", lf="+ds;
    //    s=s+atom.unparse()+"("+ds+","+cs+","+gs+","+x+","+y+
    //      ","+color_inf(p_color)+")";
    return s;
  }
  

  public void putcolor(String color) {
    if(color=="green") {p_color=Color.green; return;}
    if(color=="blue") {p_color=Color.blue; return;}
    if(color=="pink") {p_color=Color.pink; return;}
    //    ptm.ptc.drawNode(this);
  }
  
  void makeTree() {
    if (par==null) return;
    if (par.son==null) {
      par.son=this;
      born_n=0;
    } else {
      born_n=par.last.born_n+1;
      par.last.next=this;
      bros=par.last.bros;
    }
    gene=par.gene+1;
    par.last=this;
    // }
  }

  /*
  void position_calc(float left,float width,int height,PTCanvas ptc,GT cur)
  throws DispModeException {
    //System.out.println("position_calc invoked: gene="+gene+
    //		       " term="+((GTmgtp)this).lit);
    if (max_gene<gene) {
      step=(float)height/(gene+2);
      max_gene=ptc.ptv.max_gene=gene;
      ptc.og.dispose();
      ptc.coordinate_offScr(rootGT);
      rootGT.y_recalc(this,ptc,ptv,true);
      ptc.flush();
    }
    //    y=(int)(0.5+step*(gene+1));
    y=step*(gene+1);
    L=left;
    //    x=L+(int)(0.5+width/2.0);
    x=L+(float)(width/2.0);
    W=width;
    if (born_n==0) {
      if (gene>=2) ptc.drawBranch(x,y,W,bros,par.x,par.y);
      else if (gene==1) ptc.drawBranch(x,y,W,bros,rootGT.x,rootGT.y);
    }
    ptc.drawNode(this);
    if (redraw_flag) {
      if (cur==this) { 
	redraw_flag=false;
	ptc.ptv.dspMenu.setEnabled(true);
	ptc.flush();
  	if (ptc.gtc.redraw) {
	  ptc.gtc.end_redraw();
	  ptc.gtc.dec(this); // ###
	  if (ptc.ptv.disp_mode!='t') {
	    redraw_flag=true;
	    throw new DispModeException(this);
	  } 
	}
      }
    } 
    else {
      //    curGT=ptc.curGT=this; // ###
      ptc.curGT=this; // %%%
      if (ptc.zoom_redraw) {
	ptc.ZoomRedraw();
	ptc.zoom_redraw=false;
      }
      ptc.gtc.dec(this); // ###
      if (ptc.ptv.disp_mode!='t') {
	redraw_flag=true;
	throw new DispModeException(this);
      } 
    }
    if (son!=null) {
      try {
	son.position_calc(L,(float)(W/son.bros),height,ptc,cur);
      } catch(DispModeException dme1) {
	throw dme1;
      }
    }
    if (next!=null) {
      try {
	next.position_calc(L+W,W,height,ptc,cur);
      } catch(DispModeException dme2) {
	throw dme2;
      }
    }
  }
  */


  // while loop version I of position_calc
  void position_calc(float left,float width,int height,PTCanvas ptc,GT cur)
  throws DispModeException {
    //System.out.println("position_calc invoked: gene="+gene+
    //               " term="+toStr());
    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	try {
	  if (max_gene<g.gene) { // %%%

	    max_gene=ptc.ptv.max_gene=g.gene;     // %%%
	    // g.step=(float)height/((g.gene+2));   // original
	    //	    if (ptc.cvw_height<g.gene*g.step) {

	    //	    if (ptc.cvw_height-PTCanvas.bot_margin<g.gene*g.step) {
	    if (ptc.cvw_height-PTCanvas.bot_margin<(g.gene+1)*g.step) { // ###
	      g.step=(float)(height*PTCanvas.step_adjust/(g.gene+2.0));

	      ptc.og.dispose();
	      ptc.coordinate_offScr(rootGT);
	      rootGT.y_recalc(g,ptc,true);
	      ptc.flush();
	    }
	  }

	  // g.y=(int)(0.5+g.step*(g.gene+1));
	  // g.y=g.step*(g.gene+1);  // original
	  if (g==rootGT) {
	    if (g.step<PTCanvas.top_margin)
	      g.y=PTCanvas.top_margin;
	      //	      g.y=ptc.cvw_height/2;
	    else g.y=g.step;
	  }
	  else 	g.y=rootGT.y+g.step*g.gene;

	  g.L=left;
	  // x=L+(int)(0.5+width/2.0);
	  g.x=g.L+(float)(width/2.0);
	  g.W=width;
	  if (g.born_n==0) {
	    if (g.gene>=2) 
	      ptc.drawBranch(g.x,g.y,g.W,g.bros,g.par.x,g.par.y);
	    else if (g.gene==1)
	      ptc.drawBranch(g.x,g.y,g.W,g.bros,rootGT.x,rootGT.y);
	  }
	  ptc.drawNode_count(g); // %%%
	  //	  ptc.drawNode(g,g.toStr());
	  if (redraw_flag) {
	    if (cur==g) { 
	      redraw_flag=false;
	      ptc.ptv.dspMenu.setEnabled(true); // %%%
	      ptc.flush();
	      // %%%
	      if (ptc.gtc.redraw) {
	      ptc.gtc.end_redraw();
		ptc.gtc.dec(g); // ###
		if (ptc.ptv.disp_mode!='t') {
		  redraw_flag=true;
		  throw new DispModeException(g);
		} 
		// %%%
		if (ptc.ptv.resized_while_run) {
		  ptc.ptv.drawpt_susp();
		  ptc.ptv.resized_while_run=false;
		} 
		// %%%
	      }
	    }
	  } 
	  else {
	    //	    curGT=ptc.curGT=g; // ###
	    ptc.curGT=g; // %%%
	    if (ptc.zoom_redraw) { // zoom_button clicked while running
	      //System.out.println("zoom_redraw: sus"+ptc.ptv.sus);
	      ptc.ZoomRedraw();
	      ptc.zoom_redraw=false;
	    }
	    // %%%
	    ptc.gtc.dec(g); // ###
	    if (ptc.ptv.disp_mode!='t') {      
	      redraw_flag=true;
	      throw new DispModeException(g);
	    } 
	    // %%%
	    if (ptc.ptv.resized_while_run) {
	      ptc.ptv.drawpt_susp();
	      ptc.ptv.resized_while_run=false;
	    } 
	    // %%%
	  }
	} 
	catch(DispModeException dme1) {
	  throw dme1;
	}
	// process end

	if (gs.hd.son!=null) {
	  // son.position_calc(L,(float)(W/son.bros),height,ptc,cur);
	  left=g.L;
	  width=(float)(g.W/g.son.bros);
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} 
	else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } 
	  else {
	    // next.position_calc(L+W,W,height,ptc,cur);
	    left=g.L+g.W;
	    width=g.W;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } 
      else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} 
	else { // have a (younger) sibling
	  // next.position_calc(L+W,W,height,ptc,cur);
	  left=g.L+g.W;
	  width=g.W;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
  }


  // while loop version I of position_calc0
  void position_calc0(float left,float width,int height,PTCanvas ptc,GT cur) {
    //System.out.println("position_calc0 invoked: gene="+gene+
    //                 " term="+toStr());

    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	if (g==rootGT) {
	  if (g.step<PTCanvas.top_margin)
	    g.y=PTCanvas.top_margin;
	  else g.y=g.step;
	}
	else g.y=rootGT.y+g.step*g.gene;

	g.L=left;
	  // x=L+(int)(0.5+width/2.0);
	g.x=g.L+(float)(width/2.0);
	g.W=width;
	if (g.born_n==0) {
	  if (g.gene>=2) 
	    ptc.drawBranch(g.x,g.y,g.W,g.bros,g.par.x,g.par.y);
	  else if (g.gene==1)
	    ptc.drawBranch(g.x,g.y,g.W,g.bros,rootGT.x,rootGT.y);
	}
	ptc.drawNode_count(g); // %%%
	if (cur==g) { 
	  return;
	}
	// process end

	if (gs.hd.son!=null) {
	  // son.position_calc(L,(float)(W/son.bros),height,ptc,cur);
	  left=g.L;
	  width=(float)(g.W/g.son.bros);
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} 
	else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } 
	  else {
	    // next.position_calc(L+W,W,height,ptc,cur);
	    left=g.L+g.W;
	    width=g.W;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} 
	else { // have a (younger) sibling
	  // next.position_calc(L+W,W,height,ptc,cur);
	  left=g.L+g.W;
	  width=g.W;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }

  }


  /*
  // while loop version II of position_calc
  void position_calc(float left,float width,int height,PTCanvas ptc,GT cur)
  throws DispModeException {
    //System.out.println("position_calc invoked: gene="+gene+
    //                 " term="+toStr());
    GT g=this; GT ent_g=this;

    while (g!=null) {

      // process start
      try {
	if (max_gene<g.gene) { // %%%
	  max_gene=ptc.ptv.max_gene=g.gene;     // %%%
	  // g.step=(float)height/((g.gene+2));   // original
	  //	    if (ptc.cvw_height<g.gene*g.step) {
	  
	  //	  if (ptc.cvw_height-PTCanvas.bot_margin<g.gene*g.step) {
	  if (ptc.cvw_height<(g.gene+1)*g.step) { // ###
	    g.step=(float)(height*PTCanvas.step_adjust/(g.gene+2.0));
	    
	    ptc.og.dispose();
	    ptc.coordinate_offScr(rootGT);
	    rootGT.y_recalc(g,ptc,true);
	    ptc.flush();
	  }
	}
	
	// g.y=(int)(0.5+g.step*(g.gene+1));
	// g.y=g.step*(g.gene+1);  // original
	if (g==rootGT) {
	  if (g.step<PTCanvas.top_margin)
	    g.y=PTCanvas.top_margin;
	  else g.y=g.step;
	}
	else 	g.y=rootGT.y+g.step*g.gene;
	
	g.L=left;
	// x=L+(int)(0.5+width/2.0);
	g.x=g.L+(float)(width/2.0);
	g.W=width;
	if (g.born_n==0) {
	  if (g.gene>=2) 
	    ptc.drawBranch(g.x,g.y,g.W,g.bros,g.par.x,g.par.y);
	  else if (g.gene==1)
	    ptc.drawBranch(g.x,g.y,g.W,g.bros,rootGT.x,rootGT.y);
	}
	ptc.drawNode(g);
	//	ptc.drawNode(g,g.toStr());
	if (redraw_flag) {
	  if (cur==g) { 
	    redraw_flag=false;
	    ptc.ptv.dspMenu.setEnabled(true); // %%%
	    ptc.flush();
	    // %%%
	    if (ptc.gtc.redraw) {
	      ptc.gtc.end_redraw();
	      ptc.gtc.dec(g); // ###
	      //	      if (ptc.ptv.disp_mode!='t') {
	      // ###
	      if (ptc.ptv.disp_mode!='t' || ptc.ptv.wsize_changed) {
		if (ptc.ptv.wsize_changed) ptc.ptv.wsize_changed=false;
		// ### 
		redraw_flag=true;
		throw new DispModeException(g);
	      } 
	    }
	  }
	} else {
	//	curGT=ptc.curGT=g; // ###
	ptc.curGT=g; // %%%
	  if (ptc.zoom_redraw) {
	    ptc.ZoomRedraw();
	    ptc.zoom_redraw=false;
	  }
	  // %%%
	  ptc.gtc.dec(g); // ###
	  //	  if (ptc.ptv.disp_mode!='t') {      
	  // ###
	  if (ptc.ptv.disp_mode!='t' || ptc.ptv.wsize_changed) {
	    if (ptc.ptv.wsize_changed) ptc.ptv.wsize_changed=false;
	    // ###
	    redraw_flag=true;
	    throw new DispModeException(g);
	  } 
	}
      } catch(DispModeException dme1) {
	throw dme1;
      }
      // process end

      if (g.son!=null && g.son.bros==1) {
	left=g.L;
	width=(float)(g.W/g.son.bros);
	g=g.son;
      } else break;

    }

    if (g.son!=null) {
      try {
	g.son.position_calc(g.L,(float)(g.W/g.son.bros),height,ptc,cur);
      } catch(DispModeException dme1) {
	throw dme1;
      }
    }
    if (ent_g.next!=null) {
      try {
	ent_g.next.position_calc(ent_g.L+ent_g.W,ent_g.W,height,ptc,cur);
      } catch(DispModeException dme2) {
	throw dme2;
      }
    }
  }
  */  

  /*
  boolean y_recalc(GT cur,PTCanvas ptc,boolean draw){
    //System.out.println("y_calc invoked: gene="+gene+
    //                   " term="+toStr());
    // y=(int)(0.5+step*(gene+1));
    y=step*(gene+1);
    if (draw) {
      if (born_n==0) {
	if (gene>=2) ptc.drawBranch(x,y,W,bros,par.x,par.y);
	else if (gene==1) ptc.drawBranch(x,y,W,bros,rootGT.x,rootGT.y);
      }
      ptc.drawNode(this);
    }
    if (son!=null) {
      if (son==cur) return true;
      if (son.y_recalc(cur,ptc,draw)) return true;
    }
    if (next!=null) {
      if (next==cur) return true;
      if (next.y_recalc(cur,ptc,draw)) return true;
    }
    return false;
  }
  */


  // while loop version I of y_recalc
  boolean y_recalc(GT cur,PTCanvas ptc,boolean draw){
    //System.out.println("y_recalc invoked: gene="+gene+
    //                   " term="+toStr());
    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	// g.y=(int)(0.5+g.step*(g.gene+1));
	// g.y=g.step*(g.gene+1);  // original
	if (g==rootGT) {
	  if (g.step<PTCanvas.top_margin)
	    g.y=PTCanvas.top_margin;
	  else g.y=g.step;
	}
	else g.y=rootGT.y+g.step*g.gene;

	if (draw) {
	  //System.out.println("y_recalc invoked: gene="+gene+
	  //                   " term="+toStr());
	  if (g.born_n==0) {
	    if (g.gene>=2) 
	      ptc.drawBranch(g.x,g.y,g.W,g.bros,g.par.x,g.par.y);
	    else if (g.gene==1)
	      ptc.drawBranch(g.x,g.y,g.W,g.bros,rootGT.x,rootGT.y);
	  }
	  ptc.drawNode(g);
	  //	  ptc.drawNode(g,g.toStr());
	}
	// process end
	
	if (gs.hd.son!=null) {
	  // if (son==cur) return true;
	  // if (son.y_recalc(cur,ptc,draw)) return true;
	  if (g.son==cur) return true;
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } else {
	    // if (next==cur) return true;
	    // if (next.y_recalc(cur,ptc,draw)) return true;
	    if (g.next==cur) return true;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} else { // have a (younger) sibling
	  // if (next==cur) return true;
	  // if (next.y_recalc(cur,ptc,draw)) return true;
	  if (g.next==cur) return true;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
    return false;
  }


  /*
  void radial_position_calc(float Fk,float width_rad,int height_r,
			    PTCanvas ptc,GT cur)
  throws DispModeException {
    //System.out.println("radial_position_calc invoked: gene="+gene+
    // 		       " term="+toStr());

    if (max_gene<gene) {
      step=(float)height_r/(gene+1);
      max_gene=ptc.ptv.max_gene=gene;
      ptc.og.dispose();
      ptc.coordinate_offScr(rootGT);
      rootGT.r_recalc(this,ptc,true);
      ptc.flush();
    }
    R=step*gene;
    F=Fk;
    A=width_rad;
    T=F+A/2;
    //    y=(int)(R*Math.sin(T)+ptc.cvw_height/2.0+0.5);
    //    x=(int)(R*Math.cos(T)+ptc.cvw_width/2.0+0.5);
    y=(float)(R*Math.sin(T)+ptc.cvw_height/2.0);
    x=(float)(R*Math.cos(T)+ptc.cvw_width/2.0);
    if (born_n==0) {
      if (gene>=2) 
	ptc.rad_drawBranch(x,y,R,T,A,bros,par.x,par.y);
      else if (gene==1) 
	ptc.rad_drawBranch(x,y,R,T,A,bros,rootGT.x,rootGT.y);
    }
    ptc.drawNode(this);
    if (redraw_flag) {
      if (cur==this) { 
	redraw_flag=false;
	ptc.ptv.dspMenu.setEnabled(true);
	ptc.flush();
	if (ptc.gtc.redraw) {
	  ptc.gtc.end_redraw();
	  ptc.gtc.dec(this); // ###
	  if (ptc.ptv.disp_mode!='r') {
	    redraw_flag=true;
	    throw new DispModeException(this);
	  } 
	}
      }
    } else {
    //    curGT=ptc.curGT=this; // ###
    ptc.curGT=this; // %%%
      if (ptc.zoom_redraw) {
	ptc.ZoomRedraw();
	ptc.zoom_redraw=false;
      }
      ptc.gtc.dec(this); // ###
      if (ptc.ptv.disp_mode!='r') {
	redraw_flag=true;
	throw new DispModeException(this);
      } 
    }
    if (son!=null) {
      try {
	son.radial_position_calc(F,A/son.bros,height_r,ptc,cur);
      } catch(DispModeException dme1) {
	throw dme1;
      }
    }
    if (next!=null) {
      try {
	next.radial_position_calc(F+A,A,height_r,ptc,cur);
      } catch(DispModeException dme2) {
	throw dme2;
      }
    }
  }
  */


  // while loop version I of radial_position_calc
  void radial_position_calc(float Fk,float width_rad,int height_r,
  			    PTCanvas ptc,GT cur)
  throws DispModeException {
    //System.out.println("radial_position_calc invoked: gene="+gene+
    //   	       " term="+toStr());
    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	try {
	  if (max_gene<g.gene) { // %%%
	    max_gene=ptc.ptv.max_gene=g.gene; // %%%
	    //	    if (height_r<g.gene*g.step) {
	    if (height_r-PTCanvas.top_margin<g.gene*g.step) {

	      // g.step=(float)height_r/(g.gene+1);
	      g.step=(float)(height_r*PTCanvas.step_adjust/(g.gene+2.0));
	   
	      ptc.og.dispose();
	      ptc.coordinate_offScr(rootGT);
	      rootGT.r_recalc(g,ptc,true);
	      ptc.flush();
	    }
	  }
	  g.R=g.step*g.gene;
	  g.F=Fk;
	  g.A=width_rad;
	  g.T=g.F+g.A/2;
	  //    g.y=(int)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0+0.5);
	  //    g.x=(int)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0+0.5);
	  g.y=(float)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0);
	  g.x=(float)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0);
	  if (g.born_n==0) {
	    if (g.gene>=2) 
	      ptc.rad_drawBranch(g.x,g.y,g.R,g.T,g.A,g.bros,
				 g.par.x,g.par.y);
	    else if (g.gene==1) 
	      ptc.rad_drawBranch(g.x,g.y,g.R,g.T,g.A,g.bros,
				 rootGT.x,rootGT.y);
	  }
	  ptc.drawNode_count(g); // %%%
	  //	  ptc.drawNode(g,g.toStr());
	  if (redraw_flag) {
	    if (cur==g) { 
	      redraw_flag=false;
	      ptc.ptv.dspMenu.setEnabled(true); // %%%
	      ptc.flush();
	      // %%%
	      if (ptc.gtc.redraw) { 
		ptc.gtc.end_redraw();
		ptc.gtc.dec(g); // ###
		if (ptc.ptv.disp_mode!='r') {
		  redraw_flag=true;
		  throw new DispModeException(g);
		} 
		// %%%
		if (ptc.ptv.resized_while_run) {
		  ptc.ptv.drawpt_susp();
		  ptc.ptv.resized_while_run=false;
		} 
		// %%%
	      }
	    }
	  } 
	  else {
	    //	    curGT=ptc.curGT=g; // ###
	    ptc.curGT=g; // %%%
	    if (ptc.zoom_redraw) {
	      ptc.ZoomRedraw();
	      ptc.zoom_redraw=false;
	    }
	    // %%%
	    ptc.gtc.dec(g); // ###
	    if (ptc.ptv.disp_mode!='r') {
	      redraw_flag=true;
	      throw new DispModeException(g);
	    } 
	    // %%%
	    if (ptc.ptv.resized_while_run) {
	      ptc.ptv.drawpt_susp();
	      ptc.ptv.resized_while_run=false;
	    } 
	    // %%%
	  }
	} 
	catch(DispModeException dme1) {
	  throw dme1;
	}
	// process end

	if (gs.hd.son!=null) {
	  // son.radial_position_calc(F,A/son.bros,height_r,ptc,cur);
	  Fk=g.F;
	  width_rad=g.A/g.son.bros;
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} 
	else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } 
	  else {
	    // next.radial_position_calc(F+A,A,height_r,ptc,cur);
	    Fk=g.F+g.A;
	    width_rad=g.A;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } 
      else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} 
	else { // have a (younger) sibling
	  // next.radial_position_calc(F+A,A,height_r,ptc,cur);
	  Fk=g.F+g.A;
	  width_rad=g.A;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
  }


  // while loop version I of radial_position_calc0
  void radial_position_calc0(float Fk,float width_rad,int height_r,
  			    PTCanvas ptc,GT cur) {
    //System.out.println("radial_position_calc0: gene="+gene+
    //   	       " term="+toStr());

    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	g.R=g.step*g.gene;
	g.F=Fk;
	g.A=width_rad;
	g.T=g.F+g.A/2;
	//    g.y=(int)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0+0.5);
	//    g.x=(int)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0+0.5);
	g.y=(float)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0);
	g.x=(float)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0);
	if (g.born_n==0) {
	  if (g.gene>=2) 
	    ptc.rad_drawBranch(g.x,g.y,g.R,g.T,g.A,g.bros,
			       g.par.x,g.par.y);
	  else if (g.gene==1) 
	    ptc.rad_drawBranch(g.x,g.y,g.R,g.T,g.A,g.bros,
			       rootGT.x,rootGT.y);
	}
	ptc.drawNode_count(g); // %%%
	if (cur==g) {return;}
	// process end

	if (gs.hd.son!=null) {
	  // son.radial_position_calc(F,A/son.bros,height_r,ptc,cur);
	  Fk=g.F;
	  width_rad=g.A/g.son.bros;
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} 
	else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } 
	  else {
	    // next.radial_position_calc(F+A,A,height_r,ptc,cur);
	    Fk=g.F+g.A;
	    width_rad=g.A;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } 
      else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} 
	else { // have a (younger) sibling
	  // next.radial_position_calc(F+A,A,height_r,ptc,cur);
	  Fk=g.F+g.A;
	  width_rad=g.A;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
  }


  /*
  boolean r_recalc(GT cur,PTCanvas ptc,boolean draw) {
    //System.out.println("r_recalc invoked: gene="+gene+
    //  	       " term="+toStr());

    R=step*gene;
    if(draw) {
      //      y=(int)(R*Math.sin(T)+ptc.cvw_height/2.0+0.5);
      //      x=(int)(R*Math.cos(T)+ptc.cvw_width/2.0+0.5);
      y=(float)(R*Math.sin(T)+ptc.cvw_height/2.0);
      x=(float)(R*Math.cos(T)+ptc.cvw_width/2.0);
      
      if (born_n==0) {
	if (gene>=2) 
	  ptc.rad_drawBranch(x,y,R,T,A,bros,par.x,par.y);
	else if (gene==1) 
	  ptc.rad_drawBranch(x,y,R,T,A,bros,rootGT.x,rootGT.y);
      }
      ptc.drawNode(this);
    }
    if (son!=null) {
      if (son==cur) return true;
      if (son.r_recalc(cur,ptc,draw)) return true;
    }
    if (next!=null) {
      if (next==cur) return true;
      if (next.r_recalc(cur,ptc,draw)) return true;
    }
    return false;
  }
  */


  // while loop version I of r_recalc
  boolean r_recalc(GT cur,PTCanvas ptc,boolean draw) {
    //System.out.println("r_recalc invoked: gene="+gene+
    //   	       " term="+toStr());

    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	g.R=g.step*g.gene;
	if(draw) {
	  //      g.y=(int)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0+0.5);
	  //      g.x=(int)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0+0.5);
	  g.y=(float)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0);
	  g.x=(float)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0);
	  
	  if (g.born_n==0) {
	    if (g.gene>=2) 
	      ptc.rad_drawBranch(g.x,g.y,g.R,g.T,g.A,g.bros,
				 g.par.x,g.par.y);
	    else if (g.gene==1) 
	      ptc.rad_drawBranch(g.x,g.y,g.R,g.T,g.A,g.bros,
				 rootGT.x,rootGT.y);
	  }
	  ptc.drawNode(g);
	  //	  ptc.drawNode(g,g.toStr());
	}
	// process end
	
	if (gs.hd.son!=null) {
	  //if (son==cur) return true;
	  //if (son.r_recalc(cur,ptc,draw)) return true;
	  if (g.son==cur) return true;
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } else {
	    // if (next==cur) return true;
	    // if (next.r_recalc(cur,ptc,draw)) return true;
	    if (g.next==cur) return true;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} else { // have a (younger) sibling
	  // if (next==cur) return true;
	  // if (next.r_recalc(cur,ptc,draw)) return true;
	  if (g.next==cur) return true;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
    return false;
  }


  /*    
  void rad_local_position_calc(float Fk,float width_rad,int height_r,
			       PTCanvas ptc,GT cur)
  throws DispModeException {
    //System.out.println("radial_local_position_calc invoked: gene="+gene+
    //   	       " term="+toStr());

    if (max_gene<gene) {
      step=(float)height_r/(gene+1);
      max_gene=ptc.ptv.max_gene=gene;
      ptc.og.dispose();
      ptc.coordinate_offScr(rootGT);
      rootGT.r_local_recalc(this,ptc,true);
      ptc.flush();
    }
    F=Fk;
    A=width_rad;
    T=F+A/2;
    if (gene>=2) {
      //      y=m.tail.gt.y+(int)(step*Math.sin(T)+0.5);
      //      x=m.tail.gt.x+(int)(step*Math.cos(T)+0.5);
      y=par.y+(float)(step*Math.sin(T));
      x=par.x+(float)(step*Math.cos(T));
      if (born_n==0) 
	ptc.rad_local_drawBranch(x,y,step,T,A,bros,par.x,par.y);
    } else if (gene==1) {
      //      y=rootGT.y+(int)(step*Math.sin(T)+0.5);
      //      x=rootGT.x+(int)(step*Math.cos(T)+0.5);
      y=rootGT.y+(float)(step*Math.sin(T));
      x=rootGT.x+(float)(step*Math.cos(T));
      if (born_n==0) {
	ptc.rad_local_drawBranch(x,y,step,T,A,bros,rootGT.x,rootGT.y);
      }
    } else if (gene==0) {
      y=(float)(ptc.cvw_height/2.0);
      x=(float)(ptc.cvw_width/2.0);
    }
    ptc.drawNode(this);
    if (redraw_flag) {
      if (cur==this) { 
	redraw_flag=false;
	ptc.ptv.dspMenu.setEnabled(true);
	ptc.flush();
	if (ptc.gtc.redraw) {
	  ptc.gtc.end_redraw();
	  ptc.gtc.dec(this); // ###
	  if (ptc.ptv.disp_mode!='l') {
	    redraw_flag=true;
	    throw new DispModeException(this);
	  } 
	}
      }
    } else {
    //    curGT=ptc.curGT=this; // ###
    ptc.curGT=this; // %%%
      if (ptc.zoom_redraw) {
	ptc.ZoomRedraw();
	ptc.zoom_redraw=false;
      }
      ptc.gtc.dec(this); // ###
      if (ptc.ptv.disp_mode!='l') {
	redraw_flag=true;
	throw new DispModeException(this);
      } 
    }
    if (son!=null) {
      try {
	son.rad_local_position_calc(F,A/son.bros,height_r,ptc,cur);
      } catch(DispModeException dme1) {
	throw dme1;
      }
    }
    if (next!=null) {
      try {
	next.rad_local_position_calc(F+A,A,height_r,ptc,cur);
      } catch(DispModeException dme2){
	throw dme2;
      }
    }
  }
  */


  // while loop version I of rad_local_position_calc
  void rad_local_position_calc(float Fk,float width_rad,int height_r,
  			       PTCanvas ptc,GT cur)
  throws DispModeException {
    //System.out.println("radial_local_position_calc invoked: gene="+gene+
    //		       " term="+toStr());
    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	try {
	  if (max_gene<g.gene) {
	    max_gene=ptc.ptv.max_gene=g.gene;
	    //	    if (height_r<g.gene*g.step) {
	    if (height_r-PTCanvas.top_margin<g.gene*g.step) {

	      // g.step=(float)height_r/(g.gene+1);
	      g.step=(float)(height_r*PTCanvas.step_adjust/(g.gene+2.0));

	      ptc.og.dispose();
	      ptc.coordinate_offScr(rootGT);
	      rootGT.r_local_recalc(g,ptc,true);
	      ptc.flush();
	    }
	  }
	  g.F=Fk;
	  g.A=width_rad;
	  g.T=g.F+g.A/2;
	  if (g.gene>=2) {
	    //      g.y=g.m.tail.gt.y+(int)(g.step*Math.sin(g.T)+0.5);
	    //      g.x=m.tail.gt.x+(int)(g.step*Math.cos(g.T)+0.5);
	    g.y=g.par.y+(float)(g.step*Math.sin(g.T));
	    g.x=g.par.x+(float)(g.step*Math.cos(g.T));
	    if (g.born_n==0) 
	      ptc.rad_local_drawBranch(g.x,g.y,g.step,g.T,g.A,g.bros,
				       g.par.x,g.par.y);
	  } 
	  else if (g.gene==1) {
	    //      g.y=rootGT.y+(int)(g.step*Math.sin(g.T)+0.5);
	    //      g.x=rootGT.x+(int)(g.step*Math.cos(g.T)+0.5);
	    g.y=rootGT.y+(float)(g.step*Math.sin(g.T));
	    g.x=rootGT.x+(float)(g.step*Math.cos(g.T));
	    if (g.born_n==0) {
	      ptc.rad_local_drawBranch(g.x,g.y,g.step,g.T,g.A,g.bros,
				       rootGT.x,rootGT.y);
	    }
	  } 
	  else if (g.gene==0) {
	    g.y=(float)(ptc.cvw_height/2.0);
	    g.x=(float)(ptc.cvw_width/2.0);
	  }
	  ptc.drawNode_count(g); // %%%
	  //	  ptc.drawNode(g,g.toStr());
	  if (redraw_flag) {
	    if (cur==g) { 
	      redraw_flag=false;
	      ptc.ptv.dspMenu.setEnabled(true); // %%%
	      ptc.flush();
	      // %%%
	      if (ptc.gtc.redraw) {
		ptc.gtc.end_redraw();
		ptc.gtc.dec(g); // ###
		if (ptc.ptv.disp_mode!='l') {
		  redraw_flag=true;
		  throw new DispModeException(g);
		} 
		// %%%
		if (ptc.ptv.resized_while_run) {
		  ptc.ptv.drawpt_susp();
		  ptc.ptv.resized_while_run=false;
		} 
		// %%%
	      }
	    }
	  } 
	  else {
	    //	    curGT=ptc.curGT=g; // ###
	    ptc.curGT=g; // %%%
	    if (ptc.zoom_redraw) {
	      ptc.ZoomRedraw();
	      ptc.zoom_redraw=false;
	    }
	    // %%%
	    ptc.gtc.dec(g); // ###
	    if (ptc.ptv.disp_mode!='l') {
	      redraw_flag=true;
	      throw new DispModeException(g);
	    } 
	    // %%%
	    if (ptc.ptv.resized_while_run) {
	      ptc.ptv.drawpt_susp();
	      ptc.ptv.resized_while_run=false;
	    } 
	    // %%%
	  }
	} 
	catch(DispModeException dme1) {
	  throw dme1;
	}
	// process end

	if (gs.hd.son!=null) {
	  // son.rad_local_position_calc(F,A/son.bros,height_r,ptc,cur);
	  Fk=g.F;
	  width_rad=g.A/g.son.bros;
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} 
	else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } 
	  else {
	    // next.rad_local_position_calc(F+A,A,height_r,ptc,cur);
	    Fk=g.F+g.A;
	    width_rad=g.A;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } 
      else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} 
	else { // have a (younger) sibling
	  // next.rad_local_position_calc(F+A,A,height_r,ptc,cur);
	  Fk=g.F+g.A;
	  width_rad=g.A;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
  }


  // while loop version I of rad_local_position_calc0
  void rad_local_position_calc0(float Fk,float width_rad,int height_r,
				PTCanvas ptc,GT cur) {
    //System.out.println("radial_local_position_calc0: gene="+gene+
    //		       " term="+toStr());

    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	g.F=Fk;
	g.A=width_rad;
	g.T=g.F+g.A/2;
	if (g.gene>=2) {
	  //      g.y=g.m.tail.gt.y+(int)(g.step*Math.sin(g.T)+0.5);
	  //      g.x=m.tail.gt.x+(int)(g.step*Math.cos(g.T)+0.5);
	  g.y=g.par.y+(float)(g.step*Math.sin(g.T));
	  g.x=g.par.x+(float)(g.step*Math.cos(g.T));
	  if (g.born_n==0) 
	    ptc.rad_local_drawBranch(g.x,g.y,g.step,g.T,g.A,g.bros,
				     g.par.x,g.par.y);
	} 
	else if (g.gene==1) {
	  //      g.y=rootGT.y+(int)(g.step*Math.sin(g.T)+0.5);
	  //      g.x=rootGT.x+(int)(g.step*Math.cos(g.T)+0.5);
	  g.y=rootGT.y+(float)(g.step*Math.sin(g.T));
	  g.x=rootGT.x+(float)(g.step*Math.cos(g.T));
	  if (g.born_n==0) {
	    ptc.rad_local_drawBranch(g.x,g.y,g.step,g.T,g.A,g.bros,
				     rootGT.x,rootGT.y);
	  }
	} 
	else if (g.gene==0) {
	  g.y=(float)(ptc.cvw_height/2.0);
	  g.x=(float)(ptc.cvw_width/2.0);
	}
	ptc.drawNode(g);
	if (cur==g) {return;}
	// process end

	if (gs.hd.son!=null) {
	  // son.rad_local_position_calc(F,A/son.bros,height_r,ptc,cur);
	  Fk=g.F;
	  width_rad=g.A/g.son.bros;
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} 
	else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } 
	  else {
	    // next.rad_local_position_calc(F+A,A,height_r,ptc,cur);
	    Fk=g.F+g.A;
	    width_rad=g.A;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } 
      else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} 
	else { // have a (younger) sibling
	  // next.rad_local_position_calc(F+A,A,height_r,ptc,cur);
	  Fk=g.F+g.A;
	  width_rad=g.A;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
  }


  /*
  boolean r_local_recalc(GT cur,PTCanvas ptc,boolean draw) {
    if (draw) {
      if (gene>=2) {
	//	y=py+(int)(step*Math.sin(T)+0.5);
	//	x=px+(int)(step*Math.cos(T)+0.5);
	y=par.y+(float)(step*Math.sin(T));
	x=par.x+(float)(step*Math.cos(T));
	if (born_n==0) 
	  ptc.rad_local_drawBranch(x,y,step,T,A,bros,par.x,par.y);
      } else if (gene==1) {
	//	y=py+(int)(step*Math.sin(T)+0.5);
	//	x=px+(int)(step*Math.cos(T)+0.5);
	y=rootGT.y+(float)(step*Math.sin(T));
	x=rootGT.x+(float)(step*Math.cos(T));
	if (born_n==0) 
	  ptc.rad_local_drawBranch(x,y,step,T,A,bros,rootGT.x,rootGT.y);
      }else if (gene==0) {
	y=(float)(ptc.cvw_height/2.0);
	x=(float)(ptc.cvw_width/2.0);
      }
      ptc.drawNode(this);
    }
    if (son!=null) {
      if (son==cur) return true;
      if (son.r_local_recalc(cur,ptc,draw)) return true;
    }
    if (next!=null) {
      if (next==cur) return true;
      if (next.r_local_recalc(cur,ptc,draw)) return true;
    }
    return false;
  }
  */


  // while loop version I of r_local_recalc
  boolean r_local_recalc(GT cur,PTCanvas ptc,boolean draw) {
    //System.out.println("r_local_recalc invoked: gene="+gene+
    //		       " term="+toStr());
    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    while (gs!=GTStack.NIL) {
      //
      GT g=gs.hd;
      //
      if (down) {

	// process start
	if (draw) {
	  if (g.gene>=2) {
	    //	g.y=g.py+(int)(g.step*Math.sin(g.T)+0.5);
	    //	g.x=g.px+(int)(g.step*Math.cos(g.T)+0.5);
	    g.y=g.par.y+(float)(g.step*Math.sin(g.T));
	    g.x=g.par.x+(float)(g.step*Math.cos(g.T));
	    if (g.born_n==0) 
	      ptc.rad_local_drawBranch(g.x,g.y,g.step,g.T,g.A,g.bros,
				       g.par.x,g.par.y);
	  } else if (g.gene==1) {
	    //	g.y=g.py+(int)(g.step*Math.sin(g.T)+0.5);
	    //	g.x=g.px+(int)(g.step*Math.cos(g.T)+0.5);
	    g.y=rootGT.y+(float)(g.step*Math.sin(g.T));
	    g.x=rootGT.x+(float)(g.step*Math.cos(g.T));
	    if (g.born_n==0) 
	      ptc.rad_local_drawBranch(g.x,g.y,g.step,g.T,g.A,g.bros,
				       rootGT.x,rootGT.y);
	  }else if (g.gene==0) {
	    g.y=(float)(ptc.cvw_height/2.0);
	    g.x=(float)(ptc.cvw_width/2.0);
	  }
	  ptc.drawNode(g);
	  //	  ptc.drawNode(g,g.toStr());
	}
	// process end
	
	if (gs.hd.son!=null) {
	  //if (son==cur) return true;
	  //if (son.r_local_recalc(cur,ptc,draw)) return true;
	  if (g.son==cur) return true;
	  //
	  gs=new GTStack(gs.hd.son,gs);
	} else {
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } else {
	    // if (next==cur) return true;
	    //if (next.r_local_recalc(cur,ptc,draw)) return true;
	    if (g.next==cur) return true;
	    //
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } else { // up
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} else { // have a (younger) sibling
	  // if (next==cur) return true;
	  //if (next.r_local_recalc(cur,ptc,draw)) return true;
	  if (g.next==cur) return true;
	  //
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
    return false;
  }


  /*
  GT find(float cx,float cy,float dx,float dy) {
    GT retn=null;
    GT a;
    if (Math.abs(cx-x)<dx && Math.abs(cy-y)<dy) retn=this;
    if (son!=null) {
      a=son.find(cx,cy,dx,dy);
      if (a!=null) {
	if (retn==null) retn=a;
	else if ((cx-x)*(cx-x)+(cy-y)*(cy-y)>
		 (cx-a.x)*(cx-a.x)+(cy-a.y)*(cy-a.y)) retn=a;
      }
    }
    if (next!=null) { 
      a=next.find(cx,cy,dx,dy);
      if (a!=null) {
	if (retn==null) retn=a;
	else if ((cx-x)*(cx-x)+(cy-y)*(cy-y)>
		 (cx-a.x)*(cx-a.x)+(cy-a.y)*(cy-a.y)) retn=a;
      }
    }
    return retn;
  }
  */


  // while loop version II of find
  GT find(float cx,float cy,float dx,float dy) {
    GT retn=null;
    GT a;
    GT g=this; GT ent_g=this;
    
    while (g!=null) {
      
      // process start
      if (Math.abs(cx-g.x)<dx && Math.abs(cy-g.y)<dy) retn=g;
       // process end

       if (g.son!=null && g.son.bros==1) {
	 g=g.son;
       } else break;

     }

    if (g.son!=null) {
      a=g.son.find(cx,cy,dx,dy);
      if (a!=null) {
	if (retn==null) retn=a;
	else if ((cx-g.x)*(cx-g.x)+(cy-g.y)*(cy-g.y)>
		 (cx-a.x)*(cx-a.x)+(cy-a.y)*(cy-a.y)) retn=a;
      }
    }
    if (ent_g.next!=null) { 
      a=ent_g.next.find(cx,cy,dx,dy);
      if (a!=null) {
	if (retn==null) retn=a;
	else if ((cx-ent_g.x)*(cx-ent_g.x)+(cy-ent_g.y)*(cy-ent_g.y)>
		 (cx-a.x)*(cx-a.x)+(cy-a.y)*(cy-a.y)) retn=a;
      }
    }
    return retn;


  }



  //   public String unparseS_txtF(int i) {return "";}

  String color_inf(Color c) {
    if (c==Color.red) {return "r";}
    if (c==Color.green) {return "g";}
    return "b";  
  }

  /*
   int leaf_calc() {
     int par_ds;
     if(son!=null) ds=son.leaf_calc();
     else ds=1;
     if (next!=null) par_ds=ds+next.leaf_calc();
     else par_ds=ds;
     return par_ds;
  }
  */

  // while loop version I of leaf_recalc
  int leaf_calc() {
    boolean down=true;
    GTStack gs=new GTStack(this,GTStack.NIL);
    //System.out.println("new leaf_calc invoked");
    while (gs!=GTStack.NIL) {
      if (down) {
	if (gs.hd.son!=null) {
	  gs.hd.ds=0;
	  gs=new GTStack(gs.hd.son,gs);
	} else {
	  gs.hd.ds=1;
	  if (gs.tl!=GTStack.NIL) {
	    gs.tl.hd.ds+=1;
	  }
	  if (gs.hd.next==null) {
	    down=false; // up
	    gs=gs.tl;
	  } else {
	    gs=new GTStack(gs.hd.next,gs.tl);
	  }
	}
      } else { // up
	if (gs.tl!=GTStack.NIL) {
	  gs.tl.hd.ds+=gs.hd.ds;
	}
	if (gs.hd.next==null) { // have no (younger) sibling
	  gs=gs.tl;
	} else { // have a (younger) sibling
	  down=true;
	  gs=new GTStack(gs.hd.next,gs.tl);
	}
      }
    }
    return ds;
  }


  /*
  void weighted_offdraw(float left,int par_ds,float par_width,float width,
			PTCanvas ptc) {
    // %%%
    if (this==rootGT) {
      if (step<PTCanvas.top_margin)
	y=PTCanvas.top_margin;
      else y=step;
    }
    else y=rootGT.y+step*gene;
    //

    L=left;
    //    x=L+(int)(0.5+width/2.0);
    x=L+(float)(width/2.0);
    W=width;
    if (gene>=2) ptc.PTdrawLine(ptc.og,x,y,par.x,par.y);
    else if (gene==1) ptc.PTdrawLine(ptc.og,x,y,rootGT.x,rootGT.y);
    ptc.drawNode(this);
    //    ptc.drawNode(this,toStr());
    if (son!=null) 
      son.weighted_offdraw(L,ds,W,(float)(W*son.ds/ds),ptc);
    if (next!=null) 
      next.weighted_offdraw(L+W,par_ds,par_width,
			    (float)(par_width*next.ds/par_ds),ptc);
  }
  */


  // while loop version II of weighted_offdraw
  void weighted_offdraw(float left,int par_ds,float par_width,float width,
			PTCanvas ptc) {
    GT g=this; GT ent_g=this;
    while (g!=null) {

      // process start
      if (g==rootGT) {
	if (step<PTCanvas.top_margin)
	  g.y=PTCanvas.top_margin;
	else g.y=g.step;
      }
      else g.y=rootGT.y+g.step*g.gene;
      //

      g.L=left;
      //    g.x=g.L+(int)(0.5+width/2.0);
      g.x=g.L+(float)(width/2.0);
      g.W=width;
      if (g.gene>=2) ptc.PTdrawLine(ptc.og,g.x,g.y,g.par.x,g.par.y);
      else if (g.gene==1) ptc.PTdrawLine(ptc.og,g.x,g.y,rootGT.x,rootGT.y);
      ptc.drawNode_count(g); // %%%
      //      ptc.drawNode(g,g.toStr());
      // process end

      if (g.son!=null && g.son.bros==1) {
	left=g.L;
	width=(float)(g.W*g.son.ds/g.ds);
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null) 
      g.son.weighted_offdraw(g.L,g.ds,g.W,(float)(g.W*g.son.ds/g.ds),ptc);
    if (next!=null) 
      ent_g.next.weighted_offdraw(ent_g.L+ent_g.W,par_ds,par_width,
			    (float)(par_width*ent_g.next.ds/par_ds),ptc);

  }


  /*
  void r_weighted_offdraw(float Fk,int par_ds,float par_width,
			  float width_rad,PTCanvas ptc) {
    R=step*gene; // %%%

    F=Fk;
    A=width_rad;
    T=F+A/2;
    //    y=(int)(R*Math.sin(T)+ptc.cvw_height/2.0+0.5);
    //    x=(int)(R*Math.cos(T)+ptc.cvw_width/2.0+0.5);
    y=(float)(R*Math.sin(T)+ptc.cvw_height/2.0);
    x=(float)(R*Math.cos(T)+ptc.cvw_width/2.0);
    if (gene>=2) ptc.PTdrawLine(ptc.og,x,y,par.x,par.y);
    else if (gene==1) ptc.PTdrawLine(ptc.og,x,y,rootGT.x,rootGT.y);
    ptc.drawNode(this);
    //    ptc.drawNode(this,toStr());
    if (son!=null) 
      son.r_weighted_offdraw(F,ds,A,A*son.ds/ds,ptc);
    if (next!=null) 
      next.r_weighted_offdraw(F+A,par_ds,par_width,
			      par_width*next.ds/par_ds,ptc);
  }
  */


  // while loop version II of r_weighted_offdraw    
  void r_weighted_offdraw(float Fk,int par_ds,float par_width,
			  float width_rad,PTCanvas ptc) {
    GT g=this; GT ent_g=this;

    while (g!=null) {

      // process start
      g.R=g.step*g.gene; // %%%
      g.F=Fk;
      g.A=width_rad;
      g.T=g.F+g.A/2;
      //    g.y=(int)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0+0.5);
      //    g.x=(int)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0+0.5);
      g.y=(float)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0);
      g.x=(float)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0);
      if (g.gene>=2) ptc.PTdrawLine(ptc.og,g.x,g.y,g.par.x,g.par.y);
      else if (g.gene==1) ptc.PTdrawLine(ptc.og,g.x,g.y,rootGT.x,rootGT.y);
      ptc.drawNode_count(g); // %%%
      //      ptc.drawNode(g,g.toStr());
      // process end

      if (g.son!=null && g.son.bros==1) {
	Fk=g.F;
	width_rad=g.A*g.son.ds/g.ds;
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null) 
      g.son.r_weighted_offdraw(g.F,g.ds,g.A,g.A*g.son.ds/g.ds,ptc);
    if (ent_g.next!=null) 
      ent_g.next.r_weighted_offdraw(ent_g.F+ent_g.A,par_ds,par_width,
			      par_width*ent_g.next.ds/par_ds,ptc);
  }


  /*
  void r_local_weighted_offdraw(float Fk,int par_ds,float par_width,
				float width_rad,PTCanvas ptc){
    F=Fk;
    A=width_rad;
    T=F+A/2;
    if (gene>=2) {
      //      y=py+(int)(step*Math.sin(T)+0.5);
      //      x=px+(int)(step*Math.cos(T)+0.5);
      y=par.y+(float)(step*Math.sin(T));
      x=par.x+(float)(step*Math.cos(T));
      ptc.PTdrawLine(ptc.og,x,y,par.x,par.y);
    } else if (gene==1) {
      y=rootGT.y+(float)(step*Math.sin(T));
      x=rootGT.x+(float)(step*Math.cos(T));            
      ptc.PTdrawLine(ptc.og,x,y,rootGT.x,rootGT.y);
    } else if (gene==0){
      y=(float)(ptc.cvw_height/2.0);
      x=(float)(ptc.cvw_width/2.0);
    }
    ptc.drawNode(this);
    //    ptc.drawNode(this,toStr());
    if (son!=null) 
      son.r_local_weighted_offdraw(F,ds,A,A*son.ds/ds,ptc);
    if (next!=null) 
      next.r_local_weighted_offdraw(F+A,par_ds,par_width,
				    par_width*next.ds/par_ds,ptc);
  }
  */


  // while loop version II of r_local_weighted_offdraw    
  void r_local_weighted_offdraw(float Fk,int par_ds,float par_width,
				float width_rad,PTCanvas ptc) {
    GT g=this; GT ent_g=this;

    while (g!=null) {

      // process start
      g.F=Fk;
      g.A=width_rad;
      g.T=g.F+g.A/2;
      if (g.gene>=2) {
	//      g.y=g.py+(int)(g.step*Math.sin(g.T)+0.5);
	//      g.x=g.px+(int)(g.step*Math.cos(g.T)+0.5);
	g.y=g.par.y+(float)(g.step*Math.sin(g.T));
	g.x=g.par.x+(float)(g.step*Math.cos(g.T));
	ptc.PTdrawLine(ptc.og,g.x,g.y,g.par.x,g.par.y);
      } else if (g.gene==1) {
	g.y=rootGT.y+(float)(g.step*Math.sin(g.T));
	g.x=rootGT.x+(float)(g.step*Math.cos(g.T));            
	ptc.PTdrawLine(ptc.og,g.x,g.y,rootGT.x,rootGT.y);
      } else if (g.gene==0){
	g.y=(float)(ptc.cvw_height/2.0);
	g.x=(float)(ptc.cvw_width/2.0);
      }
      ptc.drawNode_count(g); // %%%
      //      ptc.drawNode(g,g.toStr());
      // process end

      if (g.son!=null && g.son.bros==1) {
	Fk=g.F;
	width_rad=g.A*g.son.ds/g.ds;
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null) 
      g.son.r_local_weighted_offdraw(g.F,g.ds,g.A,g.A*g.son.ds/g.ds,ptc);
    if (ent_g.next!=null) 
      ent_g.next.r_local_weighted_offdraw(ent_g.F+ent_g.A,par_ds,par_width,
				    par_width*ent_g.next.ds/par_ds,ptc);

  }


  /*
  void fixed_recalc(float left,float width,
		    PTCanvas ptc) {
    // %%%
    if (this==rootGT) {
      if (step<PTCanvas.top_margin)
	y=PTCanvas.top_margin;
      else y=step;
    }
    else y=rootGT.y+step*gene;
    //

    L=left;
    //    x=L+(int)(0.5+width/2.0);
    x=L+(float)(width/2.0);
    W=width;
    if (gene>=2) ptc.PTdrawLine(ptc.og,x,y,par.x,par.y);
    else if (gene==1) ptc.PTdrawLine(ptc.og,x,y,rootGT.x,rootGT.y);
    ptc.drawNode(this);
    //    ptc.drawNode(this,toStr());
    if (son!=null) son.fixed_recalc(L,(float)(W/son.bros),ptc);
    if (next!=null) next.fixed_recalc(L+W,W,ptc);
  }
  */


  // while loop version II of fixed_recalc    
  void fixed_recalc(float left,float width,PTCanvas ptc) {
    GT g=this; GT ent_g=this;
    while (g!=null) {

      // process start
      if (g==rootGT) {
	if (step<PTCanvas.top_margin)
	  g.y=PTCanvas.top_margin;
	else g.y=g.step;
	//	else g.y=rootGT.step; // ###
      }
      else g.y=rootGT.y+g.step*g.gene;
      //      else g.y=rootGT.y+rootGT.step*g.gene; // ###
      //
      
      g.L=left;
      //    g.x=g.L+(int)(0.5+width/2.0);
      g.x=g.L+(float)(width/2.0);
      g.W=width;
      if (g.gene>=2) ptc.PTdrawLine(ptc.og,g.x,g.y,g.par.x,g.par.y);
      else if (g.gene==1) ptc.PTdrawLine(ptc.og,g.x,g.y,rootGT.x,rootGT.y);
      ptc.drawNode_count(g); // %%%
      //      ptc.drawNode(g,g.toStr());
      // process end

      if (g.son!=null && g.son.bros==1) {
	left=g.L;
	width=(float)(g.W/g.son.bros);
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null) 
      g.son.fixed_recalc(g.L,(float)(g.W/g.son.bros),ptc);
    if (ent_g.next!=null) 
      ent_g.next.fixed_recalc(ent_g.L+ent_g.W,ent_g.W,ptc);

  }


  /*
  void r_fixed_recalc(float Fk,float width_rad,PTCanvas ptc) {
    R=step*gene; // %%%
    //    R=rootGT.step*gene; // ###

    F=Fk;
    A=width_rad;
    T=F+A/2;
    //    y=(int)(R*Math.sin(T)+ptc.cvw_height/2.0+0.5);
    //    x=(int)(R*Math.cos(T)+ptc.cvw_width/2.0+0.5);
    y=(float)(R*Math.sin(T)+ptc.cvw_height/2.0);
    x=(float)(R*Math.cos(T)+ptc.cvw_width/2.0);
    if (gene>=2) ptc.PTdrawLine(ptc.og,x,y,par.x,par.y);
    else if (gene==1) ptc.PTdrawLine(ptc.og,x,y,rootGT.x,rootGT.y);
    ptc.drawNode(this);
    //    ptc.drawNode(this,toStr());
    if (son!=null) son.r_fixed_recalc(F,A/son.bros,ptc);
    if (next!=null) next.r_fixed_recalc(F+A,A,ptc);
  }
  */


  // while loop version II of r_fixed_recalc    
  void r_fixed_recalc(float Fk,float width_rad,PTCanvas ptc) {
    GT g=this; GT ent_g=this;

    while (g!=null) {

      // process start
      g.R=g.step*g.gene; // %%%
      //      g.R=rootGT.step*g.gene; // ###
      g.F=Fk;
      g.A=width_rad;
      g.T=g.F+g.A/2;
      //    g.y=(int)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0+0.5);
      //    g.x=(int)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0+0.5);
      g.y=(float)(g.R*Math.sin(g.T)+ptc.cvw_height/2.0);
      g.x=(float)(g.R*Math.cos(g.T)+ptc.cvw_width/2.0);
      if (g.gene>=2) ptc.PTdrawLine(ptc.og,g.x,g.y,g.par.x,g.par.y);
      else if (g.gene==1) ptc.PTdrawLine(ptc.og,g.x,g.y,rootGT.x,rootGT.y);
      ptc.drawNode_count(g); // %%%
      //      ptc.drawNode(g,g.toStr());
      // process end

      if (g.son!=null && g.son.bros==1) {
	Fk=g.F;
	width_rad=g.A/g.son.bros;
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null) 
      g.son.r_fixed_recalc(g.F,g.A/g.son.bros,ptc);
    if (ent_g.next!=null) 
      ent_g.next.r_fixed_recalc(ent_g.F+ent_g.A,ent_g.A,ptc);

  }


  /*
  void r_local_fixed_recalc(float Fk,float width_rad,PTCanvas ptc) {
    F=Fk;
    A=width_rad;
    T=F+A/2;
    if (gene>=2) {
      //      y=py+(int)(step*Math.sin(T)+0.5);
      //      x=px+(int)(step*Math.cos(T)+0.5);
      y=par.y+(float)(step*Math.sin(T));
      x=par.x+(float)(step*Math.cos(T));
      //      y=par.y+(float)(rootGT.step*Math.sin(T)); // ###
      //      x=par.x+(float)(rootGT.step*Math.cos(T)); // ###
      ptc.PTdrawLine(ptc.og,x,y,par.x,par.y);
    } 
    else if (gene==1) {
      y=rootGT.y+(float)(step*Math.sin(T));
      x=rootGT.x+(float)(step*Math.cos(T));            
      //      y=rootGT.y+(float)(rootGT.step*Math.sin(T)); // ###
      //      x=rootGT.x+(float)(rootGT.step*Math.cos(T)); // ###     
      ptc.PTdrawLine(ptc.og,x,y,rootGT.x,rootGT.y);
    } 
    else if (gene==0) {
      y=(float)(ptc.cvw_height/2.0);
      x=(float)(ptc.cvw_width/2.0);
    }
    ptc.drawNode(this);
    //    ptc.drawNode(this,toStr());
    if (son!=null) son.r_local_fixed_recalc(F,A/son.bros,ptc);
    if (next!=null) next.r_local_fixed_recalc(F+A,A,ptc);
  }
  */


  // while loop version II of r_local_fixed_recalc    
  void r_local_fixed_recalc(float Fk,float width_rad,PTCanvas ptc) {
    GT g=this; GT ent_g=this;

    while (g!=null) {

      // process start
      g.F=Fk;
      g.A=width_rad;
      g.T=g.F+g.A/2;
      if (g.gene>=2) {
	//      g.y=g.py+(int)(g.step*Math.sin(g.T)+0.5);
	//      g.x=g.px+(int)(g.step*Math.cos(g.T)+0.5);
	g.y=g.par.y+(float)(g.step*Math.sin(g.T));
	g.x=g.par.x+(float)(g.step*Math.cos(g.T));
	//	g.y=g.par.y+(float)(rootGT.step*Math.sin(g.T)); // ###
	//	g.x=g.par.x+(float)(rootGT.step*Math.cos(g.T)); // ###
	ptc.PTdrawLine(ptc.og,g.x,g.y,g.par.x,g.par.y);
      } else if (g.gene==1) {
	g.y=rootGT.y+(float)(g.step*Math.sin(g.T));
	g.x=rootGT.x+(float)(g.step*Math.cos(g.T));            
	//	g.y=rootGT.y+(float)(rootGT.step*Math.sin(g.T)); // ###
	//	g.x=rootGT.x+(float)(rootGT.step*Math.cos(g.T)); // ###     
	ptc.PTdrawLine(ptc.og,g.x,g.y,rootGT.x,rootGT.y);
      } else if (g.gene==0) {
	g.y=(float)(ptc.cvw_height/2.0);
	g.x=(float)(ptc.cvw_width/2.0);
      }
      ptc.drawNode_count(g); // %%%
      //      ptc.drawNode(g,g.toStr());
      // process end

      if (g.son!=null && g.son.bros==1) {
	Fk=g.F;
	width_rad=g.A/g.son.bros;
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null) 
      g.son.r_local_fixed_recalc(g.F,g.A/g.son.bros,ptc);
    if (ent_g.next!=null) 
      ent_g.next.r_local_fixed_recalc(ent_g.F+ent_g.A,ent_g.A,ptc);

  }


  /*
  boolean zoom_Redraw(PTCanvas ptc,GT cur) {
    if (gene>=1 && born_n==0) {
      if (ptc.ptv.disp_mode=='t')  // %%%
	ptc.drawBranch(x,y,W,bros,par.x,par.y);
      else if (ptc.ptv.disp_mode=='r') // %%%
	ptc.rad_drawBranch(x,y,R,T,A,bros,par.x,par.y);
      else if (ptc.ptv.disp_mode=='l') 
	ptc.rad_local_drawBranch(x,y,step,T,A,bros,par.x,par.y);
    }
    ptc.drawNode(this);
    //    ptc.drawNode(this,toStr());
    if (this==cur) return true;
    if (son!=null)
      if (son.zoom_Redraw(ptc,cur)) return true;
    if (next!=null) 
      if (next.zoom_Redraw(ptc,cur)) return true;
    return false;
  }
  */


  // while loop version II of zoom_Redraw
  boolean zoom_Redraw(PTCanvas ptc,GT cur) {
    GT g=this; GT ent_g=this;
    //System.out.println("zoom_Redraw invoked: gene="+gene+
    //	       " term="+toStr());

    while (g!=null) {

      // process start
      if (g.gene>=1 && g.born_n==0) {
	if (ptc.ptv.disp_mode=='t')  // %%%
	  ptc.drawBranch(g.x,g.y,g.W,g.bros,
			 g.par.x,g.par.y);
	else if (ptc.ptv.disp_mode=='r') // %%%
	  ptc.rad_drawBranch(g.x,g.y,g.R,g.T,g.A,g.bros,
			     g.par.x,g.par.y);
	else if (ptc.ptv.disp_mode=='l') 
	  ptc.rad_local_drawBranch(g.x,g.y,g.step,g.T,g.A,g.bros,
				   g.par.x,g.par.y);
      }
      ptc.drawNode(g);
      //      ptc.drawNode(g,g.toStr());
      if (g==cur) return true;
      // process end

      if (g.son!=null && g.son.bros==1) {
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null)
      if (g.son.zoom_Redraw(ptc,cur)) return true;
    if (ent_g.next!=null) 
      if (ent_g.next.zoom_Redraw(ptc,cur)) return true;
    return false;
  }


  // while loop version II of zoom_Reset
  boolean zoom_Reset(PTCanvas ptc,GT cur) {
    GT g=this; GT ent_g=this;
    //System.out.println("zoom_Reset invoked: gene="+gene+
    //	       " term="+toStr());

    while (g!=null) {

      // process start
      if (g.gene>=1 && g.born_n==0) {
	if (ptc.ptv.disp_mode=='t')  // %%%
	  ptc.drawBranch(g.x,g.y,g.W,g.bros,
			 g.par.x,g.par.y);
	else if (ptc.ptv.disp_mode=='r') // %%%
	  ptc.rad_drawBranch(g.x,g.y,g.R,g.T,g.A,g.bros,
			     g.par.x,g.par.y);
	else if (ptc.ptv.disp_mode=='l') 
	  ptc.rad_local_drawBranch(g.x,g.y,g.step,g.T,g.A,g.bros,
				   g.par.x,g.par.y);
      }
      ptc.drawNode_count(g); // %%%
      //      ptc.drawNode(g,g.toStr());
      if (g==cur) return true;
      // process end

      if (g.son!=null && g.son.bros==1) {
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null)
      if (g.son.zoom_Reset(ptc,cur)) return true;
    if (ent_g.next!=null) 
      if (ent_g.next.zoom_Reset(ptc,cur)) return true;
    return false;
  }


  /*
  void zoom_Redraw(PTCanvas ptc) {
    if (gene>=1) ptc.PTdrawLine(ptc.og,x,y,par.x,par.y);
    ptc.drawNode(this);
    //    ptc.drawNode(this,toStr());
    if (son!=null) son.zoom_Redraw(ptc);
    if (next!=null) next.zoom_Redraw(ptc);
  }
  */


  // while loop version II of zoom_Redraw
  void zoom_Redraw(PTCanvas ptc) {
    GT g=this; GT ent_g=this;
    //    if (ptc.reset) return;
    //System.out.println("zoom_Redraw invoked: gene="+gene+" "+toStr());

    while (g!=null) {

      // process start
      if (g.gene>=1) ptc.PTdrawLine(ptc.og,g.x,g.y,g.par.x,g.par.y);
      ptc.drawNode(g);
      //      ptc.drawNode(g,g.toStr());
      // process end

      if (g.son!=null && g.son.bros==1) {
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null) g.son.zoom_Redraw(ptc);
    if (ent_g.next!=null) ent_g.next.zoom_Redraw(ptc);

  }


  // while loop version II of zoom_Reset
  void zoom_Reset(PTCanvas ptc) {
    GT g=this; GT ent_g=this;
    //    if (ptc.reset) return;
    //System.out.println("zoom_Reset invoked: gene="+gene+" "+toStr());

    while (g!=null) {

      // process start
      if (g.gene>=1) ptc.PTdrawLine(ptc.og,g.x,g.y,g.par.x,g.par.y);
      ptc.drawNode_count(g); // %%%
      //      ptc.drawNode(g,g.toStr());
      // process end

      if (g.son!=null && g.son.bros==1) {
 	g=g.son;
      } else break;
      
    }

    if (g.son!=null) g.son.zoom_Reset(ptc);
    if (ent_g.next!=null) ent_g.next.zoom_Reset(ptc);

  }


}


class GTStack {
  GT hd; GTStack tl;
  static GTStack NIL = new GTStack(); 
  GTStack () {}
  GTStack (GT g, GTStack gs) {hd=g; tl=gs;}
}



// eof


